function fireSearch(type) {
    switch(type) {
        case 1:
            buildWithServlet();
            break;

        case 2:
            buildServerSide();
            break;

        default:
            buildBasic();
    }
}

function buildServerSide() {
    buildInputSearch();
	callServlet('YbListServerSideBuilderServlet', { "responsive": true, "pageLength": 10 }, callBackServletBasic, onErrorServlet);
}

function getInputSearch() {
    return document.getElementById('search');
}

function buildInputSearch() {
    if(getInputSearch() != null) {
        return;
    }

    const searchInput = document.createElement("input");
    searchInput.id = "search";
    searchInput.placeholder = "Raison sociale";
    searchInput.type = "text";
    searchInput.addEventListener('keydown', (e) => {
        if (e.key === "Enter") {
            callServlet('YbListServerSideBuilderServlet', { "responsive": true, "pageLength": 10 }, callBackServletBasic, onErrorServlet);
        }
    });

    document.getElementById('tab_wrapper').prepend(searchInput);
}

function removeInputSearch() {
    const input = getInputSearch();
    if(input == null) {
        return;
    }
    input.remove();
}

function buildWithServlet() {
    removeInputSearch();
    drawListFromServlet("result", "YbListServlet", { "responsive": true, "pageLength": 7 }, () => { console.log('ok'); }, onErrorServlet);
}

function buildBasic() {
    removeInputSearch();
    callServlet("YbListServlet", { "responsive": false, "pageLength": 5 }, callBackServletBasic, onErrorServlet);
}

function callBackServletBasic(res) {
    const listData = JSON.parse(res);
    if(res?.error) {
        displayError(res.error);
    }
    
    try {
        drawList("result", listData);
    } catch (error) {
        displayError(error);
    }
}

function onErrorServlet(jqXHR, textStatus, errorThrown) {
    displayError(`Status ${jqXHR && jqXHR.status} - ${textStatus} : ${errorThrown}`);
}

function displayError(err) {
    if(err) {
        if(err.message) {
            $('#result').html("Une erreur est survenue : " + err.message);
        } else {
            $('#result').html("Une erreur est survenue : " + err);
        }
    } else {
        $('#result').html("Une erreur est survenue");
    }
}

function searchValueCallback() {
    return $('#search').val();
}