package com.yellowbox.plugin;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import com.yellowbox.plugin.v3.Header;
import com.yellowbox.plugin.v3.Version;
import com.yellowbox.plugin.v3.YellowboxEntryPoint;

public class DimoPlugin implements Header{

	@Override
	public String getID() {
		return "dimo.software.testcomponent";
	}

	@Override
	public String getName() {
		return "Dimo plugins Tests";
	}

	@Override
	public String getProvider() {
		return "Dimo Software";
	}

	@Override
	public Version getVersion() {
		try (InputStream input = getClass().getResourceAsStream("/assets/build.properties")) {
			Properties prop = new Properties();
			prop.load(input);
			String version = prop.getProperty("buildversion").trim();
			String[] result = version.split("\\.");
			return new Version(Integer.parseInt(result[0]), Integer.parseInt(result[1]), Integer.parseInt(result[2]));
		} catch (IOException ex) {
			ex.printStackTrace();
		}
		return null;
	}

	@Override
	public int getCodeVersion() {
		return 0;
	}

	@Override
	public String getDescription() {
		return null;
	}

	@Override
	public Version getMinYellowboxVersion() {
		return new Version(8,1,0);
	}

	@Override
	public String geteMail() {
		return null;
	}

	@Override
	public String getlogo() {
		return null;
	}

	@Override
	public void init(Version version, YellowboxEntryPoint entry) {
	}

	@Override
	public void onDelete(YellowboxEntryPoint entry) {
	}

}
