package com.yellowbox.plugin;

import java.util.ArrayList;
import java.util.List;

import com.yellowbox.plugin.v3.Component;
import com.yellowbox.plugin.v3.Param;
import com.yellowbox.plugin.v3.ParamServlet;
import com.yellowbox.plugin.v3.Params;
import com.yellowbox.plugin.v3.Servlet;
import com.yellowbox.plugin.v3.ui.UIRoot;

public class Gauge extends Component{

	private static String PARAM_POURCENT = "pourcent";
	private static String PARAM_NAME = "name";
	
	@Override
	public String getName() {
		return "Gauge";
	}

	@Override
	public String getDescription() {
		return "Affiche une gauge";
	}

	@Override
	public String getHtml() {
		String html = getRessourceAsString("/gauge/gauge.html");
		html = html.replace("${name}", getParamValues().getStringValue(PARAM_NAME));
		html = html.replace("${pourcent}", String.valueOf(getParamValues().getIntValue(PARAM_POURCENT)));
		return html;
	}

	@Override
	public List<String> getListCss() {
		List<String> list = new ArrayList<String>();
		list.add("c3-0.5.4.min.css");
		return list;
	}

	@Override
	public List<String> getListJs() {
		List<String> list = new ArrayList<String>();
		//list.add("assets/c3-0.5.4.min.js");
		list.add("https://d3js.org/d3.v4.js");
		list.add("c3-0.5.4.min.js");
		list.add("https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js");
		
		list.add("/gauge/gauge.js");
		return list;
	}

	@Override
	public List<String> getAssets() {
		return null;
	}
	
	@Override
	public Params getParams() {
		Params listParam = new Params();
		Param param1 = listParam.addNew(Param.Type.INT, Param.InOut.IN, "Pourcentage", PARAM_POURCENT);
		param1.setDescription("Pourcentage à afficher");
		
		Param param2 = listParam.addNew(Param.Type.STRING, Param.InOut.IN, "Pourcentage", PARAM_NAME);
		param2.setDescription("Nom du graphique");
		return listParam;
	}
	
	@Override
	public UIRoot getParamInstanceUI() {
		return null;
	}

	@Override
	public List<Class<? extends Servlet>> getServlets() {
		return null;
	}

	@Override
	public String getTitle() {
		return getName();
	}

	@Override
	public List<Class<? extends ParamServlet>> getParamServlets() throws AbstractMethodError {
		// TODO Auto-generated method stub
		return null;
	}


}
