package com.yellowbox.plugin;

import java.util.List;

import com.yellowbox.plugin.v3.Component;
import com.yellowbox.plugin.v3.Param;
import com.yellowbox.plugin.v3.ParamServlet;
import com.yellowbox.plugin.v3.Params;
import com.yellowbox.plugin.v3.Servlet;
import com.yellowbox.plugin.v3.ui.UIRoot;

public class IFrame extends Component{

	private String PARAM_SRC = "src";
	private String PARAM_STYLE = "style";
	
	@Override
	public String getName() {
		return "IFrame";
	}
	
	@Override
	public String getDescription() {
		return "Permet d'insérer une IFrame";
	}

	@Override
	public String getHtml() {
		String style = getParamValues().getStringValue(PARAM_STYLE);
		if(style!=null && style.equals("")) {
			style = "height:100%; border:none; width:100%;";
		}
		return "<iframe src=\"" + getParamValues().getStringValue(PARAM_SRC) + "\" style=\"" + style + "\" ></iframe>";
	}

	@Override
	public Params getParams() {
		Params listParam = new Params();
		
		Param param1 = listParam.addNew(Param.Type.STRING, Param.InOut.IN, "SRC", PARAM_SRC);
		param1.setDescription("SRC de l'iframe");
		
		Param param2 = listParam.addNew(Param.Type.STRING, Param.InOut.IN, "STYLE", PARAM_STYLE);
		param2.setDescription("Style de l'iframe non obligatoire");
		param2.setMandatory(false);
		
		return listParam;
	}

	@Override
	public List<String> getAssets() {
		return null;
	}

	@Override
	public List<String> getListCss() {
		return null;
	}

	@Override
	public List<String> getListJs() {
		return null;
	}

	@Override
	public UIRoot getParamInstanceUI() {
		return null;
	}

	@Override
	public List<Class<? extends Servlet>> getServlets() {
		return null;
	}

	@Override
	public String getTitle() {
		return getName();
	}

	@Override
	public List<Class<? extends ParamServlet>> getParamServlets() throws AbstractMethodError {
		// TODO Auto-generated method stub
		return null;
	}
	
}
