package com.yellowbox.plugin.customJsonParam;


import java.util.ArrayList;
import java.util.List;

import com.yellowbox.plugin.v3.Param;
import com.yellowbox.plugin.v3.Param.InOut;
import com.yellowbox.plugin.v3.Param.Type;
import com.yellowbox.plugin.v3.ParamServlet;
import com.yellowbox.plugin.v3.Params;
import com.yellowbox.plugin.v3.Selection;
import com.yellowbox.plugin.v3.SelectionComponent;
import com.yellowbox.plugin.v3.SelectionServlet;
import com.yellowbox.plugin.v3.ui.UIHtml;
import com.yellowbox.plugin.v3.ui.UIPanel;
import com.yellowbox.plugin.v3.ui.UIParamDefault;
import com.yellowbox.plugin.v3.ui.UIRoot;
import com.yellowbox.plugin.v3.ui.UIRow;


public class ColorPickerComponent extends SelectionComponent {

	public static final String CUSTOMPARAM = "customParam";

	
	@Override
	public String getHtml(boolean updateSelection, Selection selection) {

		String couleur = getParamValues().getStringValue(CUSTOMPARAM);

		StringBuilder html = new StringBuilder();
		html.append("<div style='min-height:200px;min-width:600px;background-color:" + couleur + "'></div>");
		
		return html.toString();
	}

	@Override
	public List<Class<? extends SelectionServlet>> getServlets() {
		List<Class<? extends SelectionServlet>> servlets = new ArrayList<>();
		return servlets;
	}

	@Override
	public List<String> getAssets() {
		List<String> listImg = new ArrayList<>();
		return listImg;	}

	@Override
	public List<String> getListCss() {
		List<String> listCss = new ArrayList<>();

		return listCss;	}

	@Override
	public List<String> getListJs() {
		List<String> listJs = new ArrayList<>();

		return listJs;	}

	@Override
	public String getDescription() {
		return "ColorPickerComponent";
	}

	@Override
	public String getName() {
		return "ColorPickerComponent";
	}

	@Override
	public UIRoot getParamInstanceUI() {

		UIRoot root = new UIRoot();
		UIPanel panel = new UIPanel("CustomParam");
		panel.add(new UIParamDefault(CUSTOMPARAM));
		UIRow line = new UIRow();
		UIHtml uiHtml = new UIHtml();
		
		/*
		 * Gestion du paramètre custom
		 */
		StringBuilder html = new StringBuilder();
		// On ajoute un script pour rendre le param invisible
		html.append("<script>"
				+ "$('#plugin_inputcustomParam').closest('.row').css('display', 'none');"
				+ "</script>");

		// On écrit le html pour le paramètre custom
		// A l'appel de "onchange", on donne au paramètre caché la valeur du paramètre custom
		html.append("<div id=\"html5DIV\"><span>Choisis ta couleur Toto :</span><input type=\"color\" id=\"html5colorpicker\" onchange=\"$('#inputvalcustomParam').val($(this).val());\" value=\"#ff0000\" style=\"width:2%;margin-left:1%;\"></div>");
		
		uiHtml.setHtml(html.toString());
		line.add(uiHtml);
		panel.add(line);
		root.add(panel);

		return root;
	}

	@Override
	public Params getParams() {
		Params parameters = new Params();

		Param param = parameters.addNew(Type.STRING, InOut.IN, "Test custom param", CUSTOMPARAM);
		param.setMandatory(false);
		parameters.add(param);
				
		return parameters;
	}

	@Override
	public String getTitle() {
		return "ColorPickerComponent";
	}

	@Override
	public List<Class<? extends ParamServlet>> getParamServlets() throws AbstractMethodError {
		// This method is not used in this component
		return null;
	}

}

