package com.yellowbox.plugin.customJsonParam;

import java.util.ArrayList;
import java.util.List;

import com.yellowbox.plugin.v3.Param;
import com.yellowbox.plugin.v3.Param.InOut;
import com.yellowbox.plugin.v3.Param.Type;
import com.yellowbox.plugin.v3.ParamServlet;
import com.yellowbox.plugin.v3.Params;
import com.yellowbox.plugin.v3.Selection;
import com.yellowbox.plugin.v3.SelectionComponent;
import com.yellowbox.plugin.v3.SelectionServlet;
import com.yellowbox.plugin.v3.ui.UIHtml;
import com.yellowbox.plugin.v3.ui.UIPanel;
import com.yellowbox.plugin.v3.ui.UIParamDefault;
import com.yellowbox.plugin.v3.ui.UIRoot;
import com.yellowbox.plugin.v3.ui.UIRow;

public class CustomJsonParamComponent extends SelectionComponent {
	
	public static final String RECHERCHEPARAM = "rechercheParam";
	public static final String RUPTUREPARAM = "ruptureParam";
	public static final String TYPECALCULPARAM = "typecalculParam";
	public static final String CHAMPCALCULPARAM = "champcalculParam";
	public static final String HIDDENPARAM = "hiddenParam";
	
	@Override
	public String getHtml(boolean updateSelection, Selection selection) {

		String jsonObject = getParamValues().getStringValue(HIDDENPARAM);

		StringBuilder html = new StringBuilder();
		html.append("<div style='min-height:200px;min-width:600px;'>" + jsonObject + "</div>");

		return html.toString();
	}

	@Override
	public List<Class<? extends SelectionServlet>> getServlets() {
		List<Class<? extends SelectionServlet>> servlets = new ArrayList<>();
		return servlets;
	}

	@Override
	public List<String> getAssets() {
		List<String> listImg = new ArrayList<>();
		return listImg;	}

	@Override
	public List<String> getListCss() {
		List<String> listCss = new ArrayList<>();

		return listCss;	}

	@Override
	public List<String> getListJs() {
		List<String> listJs = new ArrayList<>();

		return listJs;	}

	@Override
	public String getDescription() {
		return "CustomJsonParamComponent";
	}

	@Override
	public String getName() {
		return "CustomJsonParamComponent";
	}

	@Override
	public UIRoot getParamInstanceUI() {

		UIRoot root = new UIRoot();
		UIPanel panel = new UIPanel("Création d'enregistrements");
		
		panel.add(new UIParamDefault(RECHERCHEPARAM));
		panel.add(new UIParamDefault(RUPTUREPARAM));
		panel.add(new UIParamDefault(TYPECALCULPARAM));
		panel.add(new UIParamDefault(CHAMPCALCULPARAM));

		panel.add(new UIParamDefault(HIDDENPARAM));

		UIRow line = new UIRow();
		UIHtml uiHtml = new UIHtml();
		StringBuilder html = new StringBuilder();
		
		// On crée le script qui sera exécuté au click sur le bouton
		StringBuilder buttonScript = new StringBuilder(); 
		buttonScript.append("getParamsValues('selectrechercherechercheParam', $('#selectrechercherechercheParam').val(), $('#s2id_selectrechercherechercheParam').text(), 'selectchampruptureParam', $('#selectchampruptureParam').val(), $('#s2id_selectchampruptureParam').text(), 'inputvaltypecalculParam', $('#inputvaltypecalculParam').val(), $('#inputvaltypecalculParam').val(), 'selectchampchampcalculParam', $('#selectchampchampcalculParam').val(), $('#s2id_selectchampchampcalculParam').text());");
		buttonScript.append("$('#inputvalhiddenParam').val(ybList);");
		buttonScript.append("calculateList();");
		
		// On ajoute un bouton
		html.append("<button id='ybRecordButton' type='button' class='btn btn-primary' style='margin:1%;' onclick=\"" + buttonScript + "\">Créer un enregistrement</button>");

		// On charge le html pour la liste des enregistrements
		html.append(getRessourceAsString("customParam/customParam_param.html"));
		
		// On charge le javascript lié la page de paramétrage
		html.append("<script>");
		html.append(getRessourceAsString("customParam/customParam_param.js"));
		html.append("</script>");
		
		uiHtml.setHtml(html.toString());
		line.add(uiHtml);
		panel.add(line);
		root.add(panel);

		return root;
	}

	@Override
	public Params getParams() {
		Params parameters = new Params();

		Param param = parameters.addNew(Type.IDRECHERCHE, InOut.IN, "idrecherche", RECHERCHEPARAM);
		param.setMandatory(false);
		parameters.add(param);
		
		param = parameters.addNew(Type.IDFIELD, InOut.IN, "idchamprupture", RUPTUREPARAM);
		param.setMandatory(false);
		parameters.add(param);
		
		param = parameters.addNew(Type.STRING, InOut.IN, "typeCalcul", TYPECALCULPARAM);
		param.setMandatory(false);
		parameters.add(param);
		
		param = parameters.addNew(Type.IDFIELD, InOut.IN, "idchampcalcul", CHAMPCALCULPARAM);
		param.setMandatory(false);
		parameters.add(param);
		
		param = parameters.addNew(Type.STRING, InOut.IN, "Test custom param", HIDDENPARAM);
		param.setMandatory(false);
		parameters.add(param);
		
		return parameters;
	}

	@Override
	public String getTitle() {
		return "CustomJsonParamComponent";
	}

	@Override
	public List<Class<? extends ParamServlet>> getParamServlets() throws AbstractMethodError {
		// This method is not used in this component
		return null;
	}

}
