package com.yellowbox.plugin.testparams;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.yellowbox.plugin.v3.ExceptionInvalidType;
import com.yellowbox.plugin.v3.Function;
import com.yellowbox.plugin.v3.Param;
import com.yellowbox.plugin.v3.Param.InOut;
import com.yellowbox.plugin.v3.Param.Type;
import com.yellowbox.plugin.v3.ParamServlet;
import com.yellowbox.plugin.v3.ParamValues;
import com.yellowbox.plugin.v3.Params;
import com.yellowbox.plugin.v3.ui.UIRoot;

public class TestParamsFunction extends Function {

	public static final String STRING = "string";
	public static final String STRINGMULTI = "stringMulti";

	public static final String IDRECHERCHE = "idRecherche";
	public static final String IDRECHERCHEMULTI = "idRechercheMulti";

	public static final String IDTABLE = "idTable";
	public static final String IDTABLEMULTI = "idTableMulti";
	public static final String IDFIELD = "idField";
	public static final String IDFIELDMULTI = "idFieldMulti";

	public static final String MULTISELECTOR = "multiselector";

	public static final String IDUSER = "idUser";
	public static final String IDUSERMULTI = "idUserMulti";
	public static final String IDGROUP = "idGroup";
	public static final String IDGROUPMULTI = "idGroupMulti";
	public static final String IDGROUPVALUEMULTI = "idGroupValueMulti";
	public static final String IDGROUPUSER = "idGroupUser";
	public static final String IDGROUPUSERMULTIFORVALUE = "idGroupUserMultiForValue";
	public static final String IDGROUPUSERMULTIFORVALUES = "idGroupUserMultiForValues";
	public static final String IDGROUPUSERMULTI = "idGroupUserMulti";

	public static final String INT = "int";
	public static final String INTMULTI = "intMulti";
	public static final String FLOAT = "float";
	public static final String FLOATMULTI = "floatMulti";

	public static final String BOOLEAN = "boolean";
	public static final String BOOLEANMULTI = "booleanMulti";
	public static final String COLOR = "color";
	public static final String COLORMULTI = "colorMulti";
	
	public static final String DATE = "date";
	public static final String DATEMULTI = "dateMulti";
	public static final String LONGTEXT = "longText";
	public static final String LONGTEXTMULTI = "longTextMulti";
	public static final String PHONENUMBER = "phoneNumber";
	public static final String PHONENUMBERMULTI = "phoneNumberMulti";

	// DEPENDSONFIELD DependsOnField
	   
	public static final String IDFIELDSTRINGFORDEPENDENCY = "idFieldStringForDependency";
	public static final String STRINGDEPENDSONFIELD = "stringDependsOnField";
	public static final String STRINGMULTIDEPENDSONFIELD = "stringMultiDependsOnField";
	
	public static final String IDFIELDINTFORDEPENDENCY = "idFieldIntForDependency";
	public static final String INTDEPENDSONFIELD = "intDependsOnField";
	public static final String INTMULTIDEPENDSONFIELD = "intMultiDependsOnField";
	
	public static final String IDFIELDFLOATFORDEPENDENCY = "idFieldFloatForDependency";
	public static final String FLOATDEPENDSONFIELD = "floatDependsOnField";
	public static final String FLOATMULTIDEPENDSONFIELD = "floatMultiDependsOnField";

	public static final String IDFIELDUSERFORDEPENDENCY = "idFieldUserForDependency";
	public static final String IDUSERDEPENDSONFIELD = "idUserDependsOnField";
	public static final String IDUSERMULTIDEPENDSONFIELD = "idUserMultiDependsOnField";
	public static final String IDGROUPDEPENDSONFIELD = "idGroupDependsOnField";
	public static final String IDGROUPMULTIDEPENDSONFIELD = "idGroupMultiDependsOnField";
	public static final String IDGROUPUSERDEPENDSONFIELD = "idGroupUserDependsOnField";
	public static final String IDGROUPUSERMULTIDEPENDSONFIELD = "idGroupUserMultiDependsOnField";
	
	// DEPENDSONTABLE DependsOnTable
	public static final String IDRECHERCHEDEPENDSONTABLE = "idRechercheDependsOnTable";
	public static final String IDRECHERCHEMULTIDEPENDSONTABLE = "idRechercheMultiDependsOnTable";
	public static final String IDTABLEDEPENDSONTABLE = "idTableDependsOnTable";
	public static final String IDTABLEMULTIDEPENDSONTABLE = "idTableMultiDependsOnTable";
	public static final String IDFIELDDEPENDSONTABLE = "idFieldDependsOnTable";
	public static final String IDFIELDMULTIDEPENDSONTABLE = "idFieldMultiDependsOnTable";
	
	
	@Override
	public ParamValues call() {


		String string = getParamValues().getStringValue(STRING);
		List<String> stringMulti = getParamValues().getStringValues(STRINGMULTI);

		String recherche = getParamValues().getStringValue(IDRECHERCHE);
		List<String> rechercheMulti = getParamValues().getStringValues(IDRECHERCHEMULTI);
		String table = getParamValues().getStringValue(IDTABLE);
		List<String> tableMulti = getParamValues().getStringValues(IDTABLEMULTI);
		String field = getParamValues().getStringValue(IDFIELD);
		List<String> fieldMulti = getParamValues().getStringValues(IDFIELDMULTI);

		String multiselector = getParamValues().getStringValue(MULTISELECTOR);

		String user = getParamValues().getStringValue(IDUSER);
		String userValue = getParamValues().getIdUserValue(IDUSER);
		List<String> userMulti = getParamValues().getStringValues(IDUSERMULTI);
		List<String> userValueMulti = getParamValues().getIdUserValues(IDUSERMULTI);
		String group = getParamValues().getStringValue(IDGROUP);
		List<String> groupValue = getParamValues().getUsersFromGroupIds(IDGROUP);
		List<String> groupMulti = getParamValues().getStringValues(IDGROUPMULTI);
		List<String> groupValueMulti = getParamValues().getUsersFromGroupIds(IDGROUPMULTI);		
		String groupUser = getParamValues().getStringValue(IDGROUPUSER);
		List<String> groupUserValue = getParamValues().getUsersFromGroupIds(IDGROUPUSER);
		String groupUserMultiStringVal = getParamValues().getStringValue(IDGROUPUSERMULTIFORVALUES);
		List<String> groupUserMulti = getParamValues().getStringValues(IDGROUPUSERMULTIFORVALUES);
		List<String> groupUserValueMulti = getParamValues().getUsersFromGroupUserIds(IDGROUPUSERMULTI);
		

		int entier = getParamValues().getIntValue(INT);
		List<Integer> entierMulti = getParamValues().getIntValues(INTMULTI);
		float numerique = getParamValues().getFloatValue(FLOAT);
		List<Float> numeriqueMulti = getParamValues().getFloatValues(FLOATMULTI);

		boolean booleen = getParamValues().getBoolValue(BOOLEAN);
		boolean booleenMulti = getParamValues().getBoolValue(BOOLEANMULTI);
		String couleur = getParamValues().getColorValue(COLOR);
		List<String> couleurMulti = getParamValues().getColorValues(COLORMULTI);
		
		
		Date date = getParamValues().getDateValue(DATE);
		List<Date> dateMulti = getParamValues().getDateValues(DATEMULTI);
		String longtext = "";
		List<String> longtextMulti = new ArrayList<>();
		try {
			longtext = getParamValues().getLongTextrValue(LONGTEXT);
			longtextMulti = getParamValues().getLongTextrValues(LONGTEXTMULTI);
		} catch(ExceptionInvalidType exception) {
			System.out.println("ExceptionInvalidType");
		}
		String phoneNumber = getParamValues().getPhoneNumberValue(PHONENUMBER);
		List<String> phoneNumberMulti = getParamValues().getPhoneNumberValues(PHONENUMBERMULTI);

		
		String stringDependsOnField = getParamValues().getStringValue(STRINGDEPENDSONFIELD);
		List<String> stringMultiDependsOnField = getParamValues().getStringValues(STRINGMULTIDEPENDSONFIELD);
		int intDependsOnField = getParamValues().getIntValue(INTDEPENDSONFIELD);
		List<Integer> intMultiDependsOnField = getParamValues().getIntValues(INTMULTIDEPENDSONFIELD);
		float floatDependsOnField = getParamValues().getFloatValue(FLOATDEPENDSONFIELD);
		List<Float> floatMultiDependsOnField = getParamValues().getFloatValues(FLOATMULTIDEPENDSONFIELD);
		String idUserDependsOnField = getParamValues().getStringValue(IDUSERDEPENDSONFIELD);
		List<String> idUserMultiDependsOnField = getParamValues().getStringValues(IDUSERMULTIDEPENDSONFIELD);
		String idGroupDependsOnField = getParamValues().getStringValue(IDGROUPDEPENDSONFIELD);
		List<String> idGroupMultiDependsOnField = getParamValues().getStringValues(IDGROUPMULTIDEPENDSONFIELD);
		String idGroupUserDependsOnField = getParamValues().getStringValue(IDGROUPUSERDEPENDSONFIELD);
		List<String> idGroupUserMultiDependsOnField = getParamValues().getStringValues(IDGROUPUSERMULTIDEPENDSONFIELD);
		
		String idRechercheDependsOnTable = getParamValues().getStringValue(IDRECHERCHEDEPENDSONTABLE);
		List<String> idRechercheMultiDependsOnTable = getParamValues().getStringValues(IDRECHERCHEMULTIDEPENDSONTABLE);
		String idTableDependsOnTable = getParamValues().getStringValue(IDTABLEDEPENDSONTABLE);
		List<String> idTableMultiDependsOnTable = getParamValues().getStringValues(IDTABLEMULTIDEPENDSONTABLE);
		String idFieldDependsOnTable = getParamValues().getStringValue(IDFIELDDEPENDSONTABLE);
		List<String> idFieldMultiDependsOnTable = getParamValues().getStringValues(IDFIELDMULTIDEPENDSONTABLE);
		

		StringBuilder content = new StringBuilder();
		
		

		content.append("<div id=\"string\">string : " + string + "</div>");
		content.append("<div id=\"stringMulti\">stringMulti : " + stringMulti + "</div>");
		content.append("<br />");
		
		content.append("<div id=\"recherche\">recherche : " + recherche + "</div>");
		content.append("<div id=\"rechercheMulti\">rechercheMulti : " + rechercheMulti + "</div>");
		content.append("<div id=\"table\">table : " + table + "</div>");
		content.append("<div id=\"tableMulti\">tableMulti : " + tableMulti + "</div>");
		content.append("<div id=\"field\">field : " + field + "</div>");
		content.append("<div id=\"fieldMulti\">fieldMulti : " + fieldMulti + "</div>");
		
		
		content.append("<br />");

		
		content.append("<div id=\"multiselector\">multiselector : " + multiselector + "</div>");
		
		
		content.append("<br />");

		
		content.append("<div id=\"user\">user : " + user + "</div>");
		content.append("<div id=\"userValue\">userValue : " + userValue + "</div>");
		
		content.append("<div id=\"userMulti\">userMulti : " + userMulti + "</div>");
		content.append("<div id=\"userValueMulti\">userValueMulti : " + userValueMulti + "</div>");

		content.append("<div id=\"group\">group : " + group + "</div>");
		content.append("<div id=\"groupValue\">groupValue : " + groupValue + "</div>");

		content.append("<div id=\"groupMulti\">groupMulti : " + groupMulti + "</div>");
		content.append("<div id=\"groupValueMulti\">groupValueMulti : " + groupValueMulti + "</div>");
		
		content.append("<div id=\"groupUser\">groupUser : " + groupUser + "</div>");
		content.append("<div id=\"groupUserValue\">groupUserValue : " + groupUserValue + "</div>");
		
		content.append("<div id=\"groupUserMulti\">groupUserMulti : " + groupUserMulti + "</div>");
		content.append("<div id=\"groupUserMultiStringVal\">groupUserMultiStringVal : " + groupUserMultiStringVal + "</div>");
		content.append("<div id=\"groupUserValueMulti\">groupUserValueMulti : " + groupUserValueMulti + "</div>");
		
		
		content.append("<br />");

		
		content.append("<div id=\"entier\">entier : " + entier + "</div>");
		content.append("<div id=\"entierMulti\">entierMulti : " + entierMulti + "</div>");
		content.append("<div id=\"numerique\">numerique : " + numerique + "</div>");
		content.append("<div id=\"numeriqueMulti\">numeriqueMulti : " + numeriqueMulti + "</div>");
		content.append("<br />");

		content.append("<div id=\"booleen\">booleen : " + booleen + "</div>");
		content.append("<div id=\"booleenMulti\">booleenMulti : " + booleenMulti + "</div>");
		content.append("<div id=\"couleur\">couleur : " + couleur + "</div>");
		content.append("<div id=\"couleurMulti\">couleurMulti : " + couleurMulti + "</div>");
		String dateString = "";
		if(date != null) dateString = date.toString();
		content.append("<div id=\"date\">date : " + dateString + "</div>");
		content.append("<div id=\"dateMulti\">dateMulti : " + dateMulti.toString() + "</div>");
		content.append("<div id=\"longtext\">longtext : " + longtext + "</div>");
		content.append("<div id=\"longtextMulti\">longtextMulti : " + longtextMulti + "</div>");
		content.append("<div id=\"phoneNumber\">phoneNumber : " + phoneNumber + "</div>");
		content.append("<div id=\"phoneNumberMulti\">phoneNumberMulti : " + phoneNumberMulti + "</div>");
		content.append("<br />");

		content.append("<div id=\"stringDependsOnField\">stringDependsOnField : " + stringDependsOnField + "</div>");
		content.append("<div id=\"stringMultiDependsOnField\">stringMultiDependsOnField : " + stringMultiDependsOnField + "</div>");
		content.append("<div id=\"intDependsOnField\">intDependsOnField : " + intDependsOnField + "</div>");
		content.append("<div id=\"intMultiDependsOnField\">intMultiDependsOnField : " + intMultiDependsOnField + "</div>");
		content.append("<div id=\"floatDependsOnField\">floatDependsOnField : " + floatDependsOnField + "</div>");
		content.append("<div id=\"floatMultiDependsOnField\">floatMultiDependsOnField : " + floatMultiDependsOnField + "</div>");
		content.append("<div id=\"idUserDependsOnField\">idUserDependsOnField : " + idUserDependsOnField + "</div>");
		content.append("<div id=\"idUserMultiDependsOnField\">idUserMultiDependsOnField : " + idUserMultiDependsOnField + "</div>");
		content.append("<div id=\"idGroupDependsOnField\">idGroupDependsOnField : " + idGroupDependsOnField + "</div>");
		content.append("<div id=\"idGroupMultiDependsOnField\">idGroupMultiDependsOnField : " + idGroupMultiDependsOnField + "</div>");
		content.append("<div id=\"idGroupUserDependsOnField\">idGroupUserDependsOnField : " + idGroupUserDependsOnField + "</div>");
		content.append("<div id=\"idGroupUserMultiDependsOnField\">idGroupUserMultiDependsOnField : " + idGroupUserMultiDependsOnField + "</div>");
		content.append("<br />");

		content.append("<div id=\"idRechercheDependsOnTable\">idRechercheDependsOnTable : " + idRechercheDependsOnTable + "</div>");
		content.append("<div id=\"idRechercheMultiDependsOnTable\">idRechercheMultiDependsOnTable : " + idRechercheMultiDependsOnTable + "</div>");
		content.append("<div id=\"idTableDependsOnTable\">idTableDependsOnTable : " + idTableDependsOnTable + "</div>");
		content.append("<div id=\"idTableMultiDependsOnTable\">idTableMultiDependsOnTable : " + idTableMultiDependsOnTable + "</div>");
		content.append("<div id=\"idFieldDependsOnTable\">idFieldDependsOnTable : " + idFieldDependsOnTable + "</div>");
		content.append("<div id=\"idFieldMultiDependsOnTable\">idFieldMultiDependsOnTable : " + idFieldMultiDependsOnTable + "</div>");

		
		return  getParamValues();
	}


	@Override
	public String getDescription() {
		return "fonction pour tester les diff�rents types de param�tres";
	}

	@Override
	public String getName() {
		return "TestComponent_TestParamsFunction";
	}

	@Override
	public UIRoot getParamInstanceUI() {
		// Cette m�thode n'est pas utilis�e dans ce plugin.
		return null;
	}

	@Override
	public Params getParams() {
		Params parameters = new Params();

		Param paramTemp = parameters.addNew(Type.STRING, InOut.IN, "Test param string", STRING);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.STRING, InOut.IN, "Test param string en multi", STRINGMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		
		paramTemp = parameters.addNew(Type.IDRECHERCHE, InOut.IN, "Test param recherche", IDRECHERCHE);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.IDRECHERCHE, InOut.IN, "Test param recherche en multi", IDRECHERCHEMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		paramTemp = parameters.addNew(Type.IDTABLE, InOut.IN, "Test param idTable", IDTABLE);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.IDTABLE, InOut.IN, "Test param idTable en multi", IDTABLEMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField", IDFIELD);
		paramTemp.setMandatory(false);	
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField en multi", IDFIELDMULTI);
		paramTemp.setMandatory(false);	
		paramTemp.setMulti(true);
		
		
		paramTemp = parameters.addNew(Type.MULTISELECTOR, InOut.IN, "Test param multiselector", MULTISELECTOR);
		paramTemp.setMandatory(false);
		
		
		paramTemp = parameters.addNew(Type.IDUSER, InOut.IN, "Test param idUser", IDUSER);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.IDUSER, InOut.IN, "Test param idUser en multi", IDUSERMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		paramTemp = parameters.addNew(Type.IDGROUP, InOut.IN, "Test param idGroup", IDGROUP);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.IDGROUP, InOut.IN, "Test param idGroup en multi avec recup par string value", IDGROUPMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp = parameters.addNew(Type.IDGROUP, InOut.IN, "Test param idGroup avec recup par groupValue en multi", IDGROUPVALUEMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);		
		
		paramTemp = parameters.addNew(Type.IDGROUPUSER, InOut.IN, "Test param idGroupUser", IDGROUPUSER);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.IDGROUPUSER, InOut.IN, "Test param idGroupUser en multi avec recup par string value", IDGROUPUSERMULTIFORVALUE);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp = parameters.addNew(Type.IDGROUPUSER, InOut.IN, "Test param idGroupUser en multi avec recup par stringValues", IDGROUPUSERMULTIFORVALUES);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp = parameters.addNew(Type.IDGROUPUSER, InOut.IN, "Test param idGroupUser en multi avec recup par getUsersFromGrouPuserIds", IDGROUPUSERMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		
		paramTemp = parameters.addNew(Type.INT, InOut.IN, "Test param entier", INT);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.INT, InOut.IN, "Test param entier en multi", INTMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		paramTemp = parameters.addNew(Type.FLOAT, InOut.IN, "Test param num�rique", FLOAT);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.FLOAT, InOut.IN, "Test param num�rique en multi", FLOATMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);


		paramTemp = parameters.addNew(Type.BOOLEAN, InOut.IN, "Test param bool�en", BOOLEAN);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.BOOLEAN, InOut.IN, "Test param bool�en en multi", BOOLEANMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);// Aucun moyen d'emp�cher de d�clarer un param�tre bool�en "multi" mais la valeur ne sera pas prise en compte
		
		paramTemp = parameters.addNew(Type.COLOR, InOut.IN, "Test param couleur", COLOR);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.COLOR, InOut.IN, "Test param couleur en multi", COLORMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		
		paramTemp = parameters.addNew(Type.DATE, InOut.IN, "Test param date", DATE);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.DATE, InOut.IN, "Test param date en multi", DATEMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);

		paramTemp = parameters.addNew(Type.LONGTEXT, InOut.IN, "Test param longtext", LONGTEXT);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.LONGTEXT, InOut.IN, "Test param longtext en multi", LONGTEXTMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		
		paramTemp = parameters.addNew(Type.PHONENUMBER, InOut.IN, "Test param phoneNumber", PHONENUMBER);
		paramTemp.setMandatory(false);
		paramTemp = parameters.addNew(Type.PHONENUMBER, InOut.IN, "Test param phoneNumber en multi", PHONENUMBERMULTI);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		

		//  d�pendant d'un champ
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField pour d�pendance des champs string", IDFIELDSTRINGFORDEPENDENCY); 
		paramTemp.setMandatory(false);	
		paramTemp = parameters.addNew(Type.STRING, InOut.IN, "Test param string d�pendant d'un champ", STRINGDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDFIELDSTRINGFORDEPENDENCY);
		paramTemp = parameters.addNew(Type.STRING, InOut.IN, "Test param string en multi d�pendant d'un champ", STRINGMULTIDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDFIELDSTRINGFORDEPENDENCY);
		
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField pour d�pendance des champs int", IDFIELDINTFORDEPENDENCY);
		paramTemp.setMandatory(false);	
		paramTemp = parameters.addNew(Type.INT, InOut.IN, "Test param entier d�pendant d'un champ", INTDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDFIELDINTFORDEPENDENCY);
		paramTemp = parameters.addNew(Type.INT, InOut.IN, "Test param entier en multi d�pendant d'un champ", INTMULTIDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDFIELDINTFORDEPENDENCY);
		//int as string
		
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField pour d�pendance des champs float", IDFIELDFLOATFORDEPENDENCY);
		paramTemp.setMandatory(false);	
		paramTemp = parameters.addNew(Type.FLOAT, InOut.IN, "Test param num�rique d�pendant d'un champ", FLOATDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDFIELDFLOATFORDEPENDENCY);
		paramTemp = parameters.addNew(Type.FLOAT, InOut.IN, "Test param num�rique en multi d�pendant d'un champ", FLOATMULTIDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDFIELDFLOATFORDEPENDENCY);
		// float as string
		
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField pour d�pendance des champs user et groupe", IDFIELDUSERFORDEPENDENCY);
		paramTemp.setMandatory(false);	
		paramTemp = parameters.addNew(Type.IDUSER, InOut.IN, "Test param idUser d�pendant d'un champ", IDUSERDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDFIELDUSERFORDEPENDENCY);
		paramTemp = parameters.addNew(Type.IDUSER, InOut.IN, "Test param idUser en multi d�pendant d'un champ", IDUSERMULTIDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDFIELDUSERFORDEPENDENCY);
		
		paramTemp = parameters.addNew(Type.IDGROUP, InOut.IN, "Test param idGroup d�pendant d'un champ", IDGROUPDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDFIELDUSERFORDEPENDENCY);
		paramTemp = parameters.addNew(Type.IDGROUP, InOut.IN, "Test param idGroup en multi d�pendant d'un champ", IDGROUPMULTIDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDFIELDUSERFORDEPENDENCY);
		
		paramTemp = parameters.addNew(Type.IDGROUPUSER, InOut.IN, "Test param idGroupUser d�pendant d'un champ", IDGROUPUSERDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDFIELDUSERFORDEPENDENCY);
		paramTemp = parameters.addNew(Type.IDGROUPUSER, InOut.IN, "Test param idGroupUser en multi d�pendant d'un champ", IDGROUPUSERMULTIDEPENDSONFIELD);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDFIELDUSERFORDEPENDENCY);
		
		// DEPENDSONTABLE DependsOnTable  d�pendant d'une table
		paramTemp = parameters.addNew(Type.IDRECHERCHE, InOut.IN, "Test param recherche d�pendant d'une table", IDRECHERCHEDEPENDSONTABLE);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDTABLE);
		paramTemp = parameters.addNew(Type.IDRECHERCHE, InOut.IN, "Test param recherche en multi d�pendant d'une table", IDRECHERCHEMULTIDEPENDSONTABLE);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDTABLE);
		
		paramTemp = parameters.addNew(Type.IDTABLE, InOut.IN, "Test param idTable d�pendant d'une table", IDTABLEDEPENDSONTABLE);
		paramTemp.setMandatory(false);
		paramTemp.setDependsOn(IDTABLE);
		paramTemp = parameters.addNew(Type.IDTABLE, InOut.IN, "Test param idTable en multi d�pendant d'une table", IDTABLEMULTIDEPENDSONTABLE);
		paramTemp.setMandatory(false);
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDTABLE);
		
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField d�pendant d'une table", IDFIELDDEPENDSONTABLE);
		paramTemp.setMandatory(false);	
		paramTemp.setDependsOn(IDTABLE);
		paramTemp = parameters.addNew(Type.IDFIELD, InOut.IN, "Test param idField en multi d�pendant d'une table", IDFIELDMULTIDEPENDSONTABLE);
		paramTemp.setMandatory(false);	
		paramTemp.setMulti(true);
		paramTemp.setDependsOn(IDTABLE);



		return parameters;
	}

	@Override
	public String getTitle() {
		return "TestParamsFunction";
	}


	@Override
	public List<Class<? extends ParamServlet>> getParamServlets() throws AbstractMethodError {
		// TODO Auto-generated method stub
		return null;
	}



}