package com.yellowbox.plugin.yblist.components;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import com.yellowbox.plugin.v3.Component;
import com.yellowbox.plugin.v3.Param;
import com.yellowbox.plugin.v3.ParamServlet;
import com.yellowbox.plugin.v3.Params;
import com.yellowbox.plugin.v3.Servlet;
import com.yellowbox.plugin.v3.Param.InOut;
import com.yellowbox.plugin.v3.Param.Type;
import com.yellowbox.plugin.v3.ui.UIRoot;
import com.yellowbox.plugin.yblist.servlets.YbListCellServlet;
import com.yellowbox.plugin.yblist.servlets.YbListServerServlet;
import com.yellowbox.plugin.yblist.servlets.YbListServerSideBuilderServlet;
import com.yellowbox.plugin.yblist.servlets.YbListServlet;

public class YbListComponent extends Component {

	public static final String IDRECHERCHE = "IDRECHERCHE";

	@Override
	public String getHtml() {
		return getRessourceAsString("/yblist/index.html");
	}

	@Override
	public List<Class<? extends Servlet>> getServlets() {
		List<Class<? extends Servlet>> listServlet = new ArrayList<>();
		listServlet.add(YbListServlet.class);
		listServlet.add(YbListCellServlet.class);
		listServlet.add(YbListServerSideBuilderServlet.class);
		listServlet.add(YbListServerServlet.class);
		return listServlet;
	}

	@Override
	public List<String> getAssets() {
		return Collections.emptyList();
	}

	@Override
	public List<String> getListCss() {
		return Collections.emptyList();
	}

	@Override
	public List<String> getListJs() {
		List<String> listJs = new ArrayList<>();
		listJs.add("/yblist/index.js");
		return listJs;
	}

	@Override
	public String getDescription() {
		return "Exemple d'utilisation de la YbList";
	}

	@Override
	public String getName() {
		return "YbListComponent";
	}

	@Override
	public UIRoot getParamInstanceUI() {
		return null;
	}

	@Override
	public List<Class<? extends ParamServlet>> getParamServlets() throws AbstractMethodError {
		return Collections.emptyList();
	}

	@Override
	public Params getParams() {
		Params parameters = new Params();

		Param paramTemp = parameters.addNew(Type.IDRECHERCHE, InOut.IN, "Choisir une recherche sur les societes", IDRECHERCHE);
		paramTemp.setMandatory(true);
		
		return parameters;
	}

	@Override
	public String getTitle() {
		return getName();
	}

}
