package com.yellowbox.plugin.yblist.servlets;

import java.util.List;

import com.yellowbox.plugin.v3.ParamValues;
import com.yellowbox.plugin.v3.ybobjects.yblist.YbList;
import com.yellowbox.plugin.v3.ybobjects.yblist.ybcolumn.YbColumn;
import com.yellowbox.plugin.v3.ybobjects.yblist.ybserverdata.servlets.YbListBuilderServlet;
import com.yellowbox.plugin.yblist.utils.YbListUtils;

public class YbListServerSideBuilderServlet extends YbListBuilderServlet {

    @Override
    public YbList build(ParamValues params) {
        YbListUtils utils = new YbListUtils(getYellowboxEntryPoint());
        
        List<YbColumn> columns = utils.buildColumns();

		YbList ybList = new YbList(columns, YbListServerServlet.class.getSimpleName());
        ybList.setResponsive(Boolean.parseBoolean(params.getStringValue("responsive")));
        ybList.setPageLength(Integer.parseInt(params.getStringValue("pageLength")));
        ybList.setServerSide(true);
        ybList.setSearchValueJsCallbackName("searchValueCallback");

        return ybList;
    }

    @Override
    public String getName() {
        return getClass().getSimpleName();
    }

}
