package com.yellowbox.plugin.yblist.servlets;

import java.util.List;
import java.util.Map;

import com.yellowbox.plugin.v3.ParamValues;
import com.yellowbox.plugin.v3.Servlet;
import com.yellowbox.plugin.v3.ybobjects.yblist.YbList;
import com.yellowbox.plugin.v3.ybobjects.yblist.YbListException;
import com.yellowbox.plugin.v3.ybobjects.yblist.ybcell.YbCell;
import com.yellowbox.plugin.v3.ybobjects.yblist.ybcolumn.YbColumn;
import com.yellowbox.plugin.yblist.components.YbListComponent;
import com.yellowbox.plugin.yblist.utils.YbListUtils;
import com.yellowbox.ws.beans.Page;
import com.yellowbox.ws.beans.Record;

public class YbListServlet extends Servlet {

    @Override
    public String call(ParamValues params) {
        YbListUtils utils = new YbListUtils(getYellowboxEntryPoint());

        String searchId = getComponent().getParamValues().getStringValue(YbListComponent.IDRECHERCHE);
        Page<Record> records = utils.getRecordsFromSearch(searchId);

        List<YbColumn> columns = utils.buildColumns();
        List<Map<String, YbCell>> data = utils.buildData(records.getContent());

        YbList ybList = new YbList(columns, data);
        ybList.setResponsive(Boolean.parseBoolean(params.getStringValue("responsive")));
        ybList.setPageLength(Integer.parseInt(params.getStringValue("pageLength")));

        try {
            return ybList.toJson();
        } catch (YbListException e) {
            return "{ 'error': '" + e.getMessage() + "' }";
        }
    }

    @Override
    public String getName() {
        return "YbListServlet";
    }

}